<?php
/**
 * 唯品会JIT拣货单管理
 * 
 * @access public
 * @author wangbiao<wangbiao@shopex.cn>
 * @version 1.0 vopick.php 2017-02-23
 */
class console_ctl_admin_vopick extends desktop_controller{

    var $workground = "console_purchasecenter";
    
    function _views()
    {
        $pickObj    = app::get('console')->model('pick_bills');
        
        $base_filter    = array();
        $sub_menu = array(
                0 => array('label'=>__('全部'),'filter'=>$base_filter),
                1 => array('label'=>__('未审核'),'filter'=>array('status'=>1), 'optional'=>false),
                2 => array('label'=>__('已审核'),'filter'=>array('status'=>2), 'optional'=>false),
        );
        
        foreach($sub_menu as $k => $v)
        {
            $sub_menu[$k]['filter'] = $v['filter'] ? $v['filter'] : null;
            $sub_menu[$k]['addon'] = $pickObj->viewcount($v['filter']);
            $sub_menu[$k]['href'] = 'index.php?app=console&ctl=admin_vopick&act=index&view='. $k;
        }
        
        return $sub_menu;
    }
    
    function index()
    {
        $this->title = '拣货单列表';
        
        $params = array('title'=>$this->title,
                'use_buildin_set_tag'=>false,
                'use_buildin_filter'=>true,
                'use_buildin_export'=>false,
                'use_buildin_import'=>false,
                'use_buildin_recycle'=>false,
        );
        
        $this->finder('console_mdl_pick_bills', $params);
    }
    
    /**
     * 审核
     */
    function check($bill_id)
    {
        if(empty($bill_id)){
            die('操作出错，请重新操作');
        }
        
        $purchaseLib    = kernel::single('purchase_purchase_order');
        
        $pickInfo   = array();
        $pickObj    = app::get('console')->model('pick_bills');
        $pickInfo   = $pickObj->dump(array('bill_id'=>$bill_id, 'status'=>1), '*');
        
        if(empty($pickInfo)){
            die('没有相关记录，无效操作');
        }
        if($pickInfo['status'] == 2){
            die('拣货单已审核,禁止操作');
        }
        
        //OMS仓库(只支持自有仓储、伊藤忠仓储)
        $branch_list    = $purchaseLib->get_branch_list();
        $this->pagedata['branchList']    = $branch_list;
        
        //唯品会仓库
        $branchInfo     = $purchaseLib->getWarehouse($pickInfo['to_branch_bn']);
        $pickInfo['in_branch_name']    = $branchInfo['branch_name'];
        
        //同仓拣货单
        $pickLib    = kernel::single('purchase_purchase_pick');
        $combinePicks    = $pickLib->fetchCombinePick($pickInfo);
        
        $this->pagedata['jsonCombinePicks'] = json_encode($combinePicks);
        
        //去除本身
        unset($combinePicks[$bill_id]);
        $this->pagedata['combinePicks'] = $combinePicks;
        
        $pickInfo['create_time']    = date('Y-m-d H:i:s', $pickInfo['create_time']);
        $this->pagedata['pickInfo'] = $pickInfo;
        $this->singlepage('admin/vop/vopick_check.html');
    }
    
    /**
     * 保存审核
     */
    function doCheck()
    {
        $this->begin('index.php?app=console&ctl=admin_vopick&act=index');
        
        $pickObj        = app::get('console')->model('pick_bills');
        $pickItemsObj   = app::get('purchase')->model('pick_bill_items');
        $pickLib        = kernel::single('purchase_purchase_pick');
        $logObj         = app::get('ome')->model('operation_log');
        
        $bill_id        = intval($_POST['bill_id']);
        $out_branch_id  = intval($_POST['out_branch_id']);
        $bill_ids       = $_POST['bill_ids'];
        
        $bill_ids[]    = $bill_id;
        $bill_ids      = array_filter($bill_ids);
        unset($_POST, $bill_id);
        
        if(empty($bill_ids) || empty($out_branch_id))
        {
            $this->end(false, "无效操作,请检查!");
        }
        
        //拣货单信息
        $pickList   = $pickObj->getList('*', array('bill_id'=>$bill_ids));
        if(empty($pickList))
        {
            $this->end(false, "拣货单不存在,请检查!");
        }
        
        //检查
        $itemList        = array();
        $to_branch_bn    = $pickList[0]['to_branch_bn'];
        $true_num        = 0;
        $is_reissue      = false;//是否补发
        $error_msg       = '';
        
        foreach ($pickList as $p_key => $p_val)
        {
            $bill_id         = $p_val['bill_id'];
            
            $pick_num        = $p_val['pick_num'];
            $delivery_num    = $p_val['delivery_num'];
            $true_num        += ($pick_num - $delivery_num);
            
            //是否同入仓
            if($to_branch_bn != $p_val['to_branch_bn'])
            {
                $this->end(false, "不是同入库仓拣货单不能合并!");
            }
            
            //状态
            if($p_val['status'] == 2)
            {
                if($p_val['delivery_status'] == 1)
                {
                    $this->end(false, "拣货单已审核过,不能重复操作!");
                }elseif($delivery_num > $pick_num)
                {
                    $this->end(false, "拣货单已完成发货,不能重复操作!");
                }
                
                $is_reissue    = true;
            }
            
            //检查是否存在未出库的出库单
            $sql    = "SELECT a.stockout_id FROM sdb_purchase_pick_stockout AS a LEFT JOIN sdb_purchase_pick_stockout_bills AS b
                       ON a.stockout_id=b.stockout_id WHERE a.bill_id=". $bill_id ." AND b.status=1";
            $stockoutInfo    = $pickObj->db->selectrow($sql);
            if($stockoutInfo)
            {
                $this->end(false, "出库单已存在或者需要确认出库，请检查!");
            }
            
            //拣货单明细
            $pickDetail      = $pickItemsObj->getList('*', array('bill_id'=>$bill_id));
            foreach ($pickDetail as $i_key => $item)
            {
                //货号是否存在并检查仓库供货关系
                $product_id    = $pickLib->checkProduct($item['bn'], $out_branch_id, $error_msg);
                if(!$product_id)
                {
                    $this->end(false, $error_msg);
                }
                
                $num    = $item['num'];
                
                //补发计算剩余未发货数量
                if($is_reissue)
                {
                    $sql            = "SELECT sum(actual_num) as num FROM sdb_purchase_pick_stockout_bill_items 
                                       WHERE po_id=". $p_val['po_id'] ." AND bill_id=". $bill_id. " AND bn='". $item['bn'] ."'";
                    $actual_num    = $pickObj->db->selectrow($sql);
                    
                    $num    = $num - intval($actual_num['num']);
                    if($num <= 0)
                    {
                        continue;//货品数量已发完，跳过
                    }
                }
                
                //组织数据
                $itemList[]    = array(
                            'po_id'=>$p_val['po_id'],//采购单ID
                            'bill_id'=>$bill_id,//拣货单ID
                            'product_name' => $item['product_name'],
                            'bn' => $item['bn'],
                            'barcode' => $item['barcode'],
                            'size' => $item['size'],
                            'num' => $num,
                            'actual_num' => 0,//实际出库数量
                            'price' => $item['price'],
                            'market_price' => $item['market_price'],
                );
            }
        }
        
        //组织数据
        $data    = array(
                'branch_id' => $out_branch_id,//出库仓库
                'pick_num' => $true_num,//拣货数量
                'dly_mode' => 1,//配送方式 默认:1
                'bill_ids'=>$bill_ids,
                'detail'=>$itemList,
        );
        
        //创建
        $stockLib    = kernel::single('purchase_purchase_stockout');
        $stockout_no = $stockLib->create_stockout($data);
        if(!$stockout_no)
        {
            $this->end(true, '创建出库单失败');
        }
        
        //更新审核状态
        $pickObj->update(array('status'=>2), array('bill_id'=>$bill_ids));
        
        //日志
        $log_str    = '审核完成，';
        $log_str    .= (count($bill_ids)> 1 ? '合并' : '') .'创建出库单号：'. $stockout_no;
        foreach ($bill_ids as $key => $bill_id)
        {
            $logObj->write_log('check_vopick@ome', $bill_id, $log_str);
        }
        
        $this->end(true, '审核完成');
    }
    
    /**
     * 补发
     */
    function recheck($bill_id)
    {
        if(empty($bill_id)){
            die('操作出错，请重新操作');
        }
        $purchaseLib    = kernel::single('purchase_purchase_order');
        
        $pickInfo   = array();
        $pickObj    = app::get('console')->model('pick_bills');
        $pickInfo   = $pickObj->dump(array('bill_id'=>$bill_id, 'status'=>2, 'delivery_status'=>2), '*');
        
        if(empty($pickInfo)){
            die('没有相关记录，无效操作');
        }
        
        if($pickInfo['pick_num'] < $pickInfo['delivery_num']){
            die('拣货单已完成发货,禁止操作');
        }
        
        //OMS仓库(只支持自有仓储、伊藤忠仓储)
        $branch_list    = $purchaseLib->get_branch_list();
        $this->pagedata['branchList']    = $branch_list;
        
        //唯品会仓库
        $branchInfo     = $purchaseLib->getWarehouse($pickInfo['to_branch_bn']);
        $pickInfo['in_branch_name']    = $branchInfo['branch_name'];
        
        //同仓拣货单
        $pickLib    = kernel::single('purchase_purchase_pick');
        $combinePicks    = $pickLib->fetchCombinePick($pickInfo, true);
        $this->pagedata['jsonCombinePicks'] = json_encode($combinePicks);
        
        //去除本身
        unset($combinePicks[$bill_id]);
        $this->pagedata['combinePicks'] = $combinePicks;
        
        $pickInfo['create_time']    = date('Y-m-d H:i:s', $pickInfo['create_time']);
        $pickInfo['is_delivery']    = true;
        $this->pagedata['pickInfo'] = $pickInfo;
        $this->singlepage('admin/vop/vopick_check.html');
    }
}