<?php
/**
 * 唯品会JIT采购单管理
 * 
 * @access public
 * @author wangbiao<wangbiao@shopex.cn>
 * @version 1.0 vopurchase.php 2017-02-23
 */
class console_ctl_admin_vopurchase extends desktop_controller{
    
    var $workground = "console_purchasecenter";
    
    function _views()
    {
        $purchaseObj    = app::get('console')->model('order');
        
        $base_filter    = array();
        $dateline       = time();
        $sub_menu = array(
                0 => array('label'=>__('全部'),'filter'=>$base_filter),
                1 => array('label'=>__('进行中'),'filter'=>array('unpick_num|than'=>0, 'sell_et_time|lthan'=>$dateline), 'optional'=>false),
                2 => array('label'=>__('档期已结束'),'filter'=>array('sell_et_time|sthan'=>$dateline), 'optional'=>false),
        );
        
        foreach($sub_menu as $k => $v)
        {
            $sub_menu[$k]['filter'] = $v['filter'] ? $v['filter'] : null;
            $sub_menu[$k]['addon'] = $purchaseObj->viewcount($v['filter']);
            $sub_menu[$k]['href'] = 'index.php?app=console&ctl=admin_vopurchase&act=index&view='. $k;
        }
        
        return $sub_menu;
    }
    
    function index()
    {
        $this->title = '采购单列表';
        
        $params = array(
                'title'=>$this->title,
                'use_buildin_set_tag'=>false,
                'use_buildin_filter'=>true,
                'use_buildin_export'=>false,
                'use_buildin_import'=>false,
                'use_buildin_recycle'=>false,
                'actions'=>array(
                    array(
                        'label' => '获取采购单',
                        'href' => 'index.php?app=console&ctl=admin_vopurchase&act=get_po_page',
                        'target' => 'dialog::{width:400,height:200,title:\'获取采购单\'}'
                    ),
                ),
        );
        
        $this->finder('console_mdl_order', $params);
    }
    
    /**
     * 人工点击生成拣货单
     */
    function createPick()
    {
        @set_time_limit(0);
        @ini_set('memory_limit','128M');
        
        $rsp = array('rsp'=>'fail', 'error_msg'=>'');
        
        $po_id    = $_POST['po_id'];
        if(empty($po_id))
        {
            $rsp['error_msg']    = '无效操作';
            echo json_encode($rsp, true);
            exit;
        }
        
        $purchaseObj    = app::get('purchase')->model('order');
        $poInfo         = $purchaseObj->dump(array('po_id'=>$po_id), 'po_bn, shop_id, unpick_num');
        
        $finder_id    = $_GET['finder_id'];
        $po_no        = $poInfo['po_bn'];
        $shop_id      = $poInfo['shop_id'];
        
        $po_nos       = array();
        $pick_list    = array();
        
        if($poInfo['unpick_num'])
        {
            //创建拣货单
            $param  = array('po_no'=>$po_no);
            
            //超时请求3次
            $requestCount = 0;
            do {
                $rsp    = kernel::single('erpapi_router_request')->set('shop', $shop_id)->purchase_createPick($param);
                
                //判断是否请求超时
                if ($rsp['rsp'] != 'fail' || ($rsp['res_ltype'] != 1 && $rsp['res_ltype'] != 2))
                {
                    break;
                }
                
                $requestCount++;
            } while ($requestCount<3);
            
            if($rsp['rsp']=='succ' && $rsp['pick_info'])
            {
                $po_nos[]    = $po_no;
            }
            elseif($rsp['rsp']=='fail') 
            {
                $rsp['err_msg']    = ($rsp['err_msg'] ? $rsp['err_msg'] : '创建拣货单失败');
                
                $rsp['error_msg']    = $rsp['err_msg'];
                echo json_encode($rsp, true);
                exit;
            }
        }
        
        //拉取拣货单
        if($po_nos)
        {
            $param     = array('po_no' => implode(',', $po_nos));
            
            //超时请求3次
            $requestCount = 0;
            do {
                $rsp  = kernel::single('erpapi_router_request')->set('shop', $shop_id)->purchase_getPickList($param);
                
                //判断是否请求超时
                if ($rsp['rsp'] != 'fail' || ($rsp['res_ltype'] != 1 && $rsp['res_ltype'] != 2))
                {
                    break;
                }
                
                $requestCount++;
            } while ($requestCount<3);
            
            //拉取拣货单明细
            if($rsp['rsp'] == 'succ' && $rsp['po_list'])
            {
                foreach ($rsp['po_list'] as $pi_key => $pi_val)
                {
                    $param       = array('po_no'=>$pi_val['po_no'], 'pick_no'=>$pi_val['pick_no']);
                    $rsp_detail  = kernel::single('erpapi_router_request')->set('shop', $shop_id)->purchase_getPickDetail($param);
                    
                    //组织拣货单信息
                    if($rsp_detail['rsp'] == 'succ' && $rsp_detail['pick_product_list'])
                    {
                        $pick_list[$pi_key]    = $pi_val;
                        $pick_list[$pi_key]['product_list']    = $rsp_detail['pick_product_list'];
                    }
                }
            }
        }
        
        //保存拣货单
        if($pick_list)
        {
            $pickLib   = kernel::single('purchase_purchase_pick');
            $result    = $pickLib->save_pick($pick_list);
        }
        
        
        $rsp = array('rsp'=>'succ');
        if(empty($po_nos))
        {
            $rsp['error_msg']    = '没有可拉取的拣货单';
        }
        echo json_encode($rsp, true);
        exit;
    }
    
    /**
     * 获取前端店铺采购单
     */
    function sync_purchase()
    {
        $purchaseLib  = kernel::single('purchase_purchase_order');
        
        $po_no      = $_POST['purchase_bn'];
        $shop_id    = $_POST['shop_id'];
        
        if(empty($po_no)){
            echo json_encode(array('rsp'=>'fail','msg'=>'采购单号不能为空!'));exit;
        }
        if(empty($shop_id)){
            echo json_encode(array('rsp'=>'fail','msg'=>'店铺ID不能为空!'));exit;
        }
        
        //唯品会店铺
        $shopInfo    = $purchaseLib->get_vop_shop_list($shop_id);
        $shopInfo    = $shopInfo[0];
        
        if(empty($shopInfo['node_id']))
        {
            echo json_encode(array('rsp'=>'fail','msg'=>'店铺未绑定'));
            exit;
        }
        
        //请求VOP
        $param    = array('po_no'=>$po_no);
        $rsp      = kernel::single('erpapi_router_request')->set('shop', $shop_id)->purchase_getPullPo($param);
        
        if($rsp['rsp'] == 'succ')
        {
            //拉取拣货单列表
            if($rsp['po_nos'])
            {
                $po_nos    = implode(',', $rsp['po_nos']);
                $param     = array('po_no'=>$po_nos);
                $rsp_data  = kernel::single('erpapi_router_request')->set('shop', $shop_id)->purchase_getPickList($param);
                
                //拉取拣货单明细
                if($rsp_data['rsp'] == 'succ' && $rsp_data['po_list'])
                {
                    foreach ($rsp_data['po_list'] as $pi_key => $pi_val)
                    {
                        $param       = array('po_no'=>$pi_val['po_no'], 'pick_no'=>$pi_val['pick_no']);
                        $rsp_detail  = kernel::single('erpapi_router_request')->set('shop', $shop_id)->purchase_getPickDetail($param);
                        
                        //组织拣货单信息
                        if($rsp_detail['rsp'] == 'succ' && $rsp_detail['pick_product_list'])
                        {
                            $pick_list[$pi_key]    = $pi_val;
                            $pick_list[$pi_key]['product_list']    = $rsp_detail['pick_product_list'];
                        }
                    }
                }
                
                //保存拣货单
                if($pick_list)
                {
                    $voPurchaseLib    = kernel::single('ome_autotask_vopurchase');
                    $result    = $voPurchaseLib->save_pick($pick_list);
                }
            }
            
            echo json_encode(array('rsp'=>'succ'));
        }
        else
        {
            $rsp['err_msg']    = ($rsp['err_msg'] ? $rsp['err_msg'] : '同步采购单失败。');
            echo json_encode(array('rsp'=>'fail', 'msg'=>$rsp['err_msg']));
        }
    }
    
    /**
     * [创建拣货单]弹窗页
     */
    function confirm($po_id)
    {
        $purchaseObj    = app::get('purchase')->model('order');
        $poInfo         = $purchaseObj->dump(array('po_id'=>$po_id), 'po_id, po_bn, shop_id, unpick_num');
        
        $finder_id    = $_GET['finder_id'];
        
        $this->pagedata['finder_id'] = $finder_id;
        $this->pagedata['data'] = $poInfo;
        $this->pagedata['single'] = 1;
        $this->display("admin/vop/order_alert.html");
    }
    
    /**
     * [获取采购单]弹窗页
     */
    function get_po_page()
    {
        $purchaseLib  = kernel::single('purchase_purchase_order');
        $purchaseObj  = app::get('purchase')->model('order');
        
        //唯品会JIT店铺
        $shopList     = $purchaseLib->get_vop_shop_list();
        $this->pagedata['shop_list']    = $shopList;
        
        $this->display('admin/vop/order_po.html');
    }
    
    function get_order()
    {
        $this->begin("");
        
        $po_no      = $_POST['purchase_bn'];
        $shop_id    = $_POST['shop_id'];
        
        if(empty($shop_id)){
            $this->end(false,'请选择店铺!');
        }
        if(empty($po_no)){
            $this->end(false,'采购单号不能为空!');
        }
        
        //唯品会店铺
        $purchaseLib  = kernel::single('purchase_purchase_order');
        $shopInfo     = $purchaseLib->get_vop_shop_list($shop_id);
        $shopInfo     = $shopInfo[0];
        
        if(empty($shopInfo['node_id']))
        {
            $this->end(false,'店铺未绑定!');
        }
        
        //请求VOP
        $param    = array('po_no'=>$po_no);
        $rsp      = kernel::single('erpapi_router_request')->set('shop', $shop_id)->purchase_getPullPo($param);
        
        if($rsp['rsp'] == 'succ')
        {
            //拉取拣货单列表
            if($rsp['po_nos'])
            {
                $po_nos    = implode(',', $rsp['po_nos']);
                $param     = array('po_no'=>$po_nos);
                $rsp_data  = kernel::single('erpapi_router_request')->set('shop', $shop_id)->purchase_getPickList($param);
                
                //拉取拣货单明细
                if($rsp_data['rsp'] == 'succ' && $rsp_data['po_list'])
                {
                    foreach ($rsp_data['po_list'] as $pi_key => $pi_val)
                    {
                        $param       = array('po_no'=>$pi_val['po_no'], 'pick_no'=>$pi_val['pick_no']);
                        $rsp_detail  = kernel::single('erpapi_router_request')->set('shop', $shop_id)->purchase_getPickDetail($param);
                        
                        //组织拣货单信息
                        if($rsp_detail['rsp'] == 'succ' && $rsp_detail['pick_product_list'])
                        {
                            $pick_list[$pi_key]    = $pi_val;
                            $pick_list[$pi_key]['product_list']    = $rsp_detail['pick_product_list'];
                        }
                    }
                }
                
                //保存拣货单
                if($pick_list)
                {
                    $voPurchaseLib    = kernel::single('ome_autotask_vopurchase');
                    $result    = $voPurchaseLib->save_pick($pick_list);
                }
            }
            else
            {
                $this->end(false, '没有获取到采购单!');
            }
        }
        else
        {
            $rsp['err_msg']    = ($rsp['err_msg'] ? $rsp['err_msg'] : '同步采购单失败。');
            $this->end(false, $rsp['err_msg']);
        }
        
        $this->end(true, '获取采购单单号：'. $po_no .' 成功!');
    }
}