<?php
/**
 * 更新历史数据，标记门店履约订单的处理状态
 * 
 * @author xiayuanjun@shopex.cn
 * @version 1.0
 */

$domain = $argv[1];
$order_id = $argv[2];
$host_id = $argv[3];

if (empty($domain) || empty($order_id) || empty($host_id)) {

	die('No Params');
}

set_time_limit(0);

require_once(dirname(__FILE__) . '/../../lib/init.php');

cachemgr::init(false);

$db = kernel::database();

$dlyCorpObj    = app::get('ome')->model('dly_corp');
$corpList      = $dlyCorpObj->getList('corp_id', array('d_type'=>2));
if(!$corpList){
    return false;
}

$logi_ids      = array();
foreach ($corpList as $key => $val)
{
    $logi_ids[]    = $val['corp_id'];
}

if($logi_ids){
    $orderObj = app::get('ome')->model("orders");
    $orderList = $orderObj->getList('order_id',array('logi_id' => $logi_ids, 'ship_status'=>1), 0, -1);
    if(!$orderList){
        return false;
    }

    $order_ids      = array();
    foreach ($orderList as $key => $val)
    {
        $order_ids[]    = $val['order_id'];
    }
}

//找到已发货的门店订单更新门店处理状态为已发货
if($order_ids){
    $db->exec('UPDATE sdb_ome_order_extend SET store_process_status=4 WHERE order_id in ('.implode(',', $order_ids).')');
}

//找到已核销的门店订单更新门店处理状态为已核销
$sql = "SELECT O.order_id FROM sdb_ome_orders AS O 
            LEFT JOIN sdb_ome_delivery_order AS DO ON O.order_id = DO.order_id 
            LEFT JOIN sdb_ome_delivery AS D ON DO.delivery_id = D.delivery_id 
            WHERE (D.parent_id=0 OR D.is_bind='true') AND D.is_received =2";
$orderList2    = $db->select($sql);
if(!$orderList2){
    return false;
}

$order_ids2      = array();
foreach ($orderList2 as $key => $val)
{
    $order_ids2[]    = $val['order_id'];
}

if($order_ids2){
    $db->exec('UPDATE sdb_ome_order_extend SET store_process_status=5 WHERE order_id in ('.implode(',', $order_ids2).')');
}