<?php
/**
 * 转化members表信息至sdb_ome_member_address表中
 * 
 * @author sunjing@shopex.cn
 * @version 1.0
 */

$domain = $argv[1];
$order_id = $argv[2];
$host_id = $argv[3];

if (empty($domain) || empty($order_id) || empty($host_id)) {

	die('No Params');
}

set_time_limit(0);

require_once(dirname(__FILE__) . '/../../lib/init.php');

cachemgr::init(false);
$db = kernel::database();
$shopObj = app::get('ome')->model('shop');
$shops = $shopObj->getlist();
$shop_list = array();
foreach($shops  as $shop){
	$shop_list[$shop['shop_id']] = $shop;
}
$members = $db->selectrow("SELECT count(member_id) AS _total FROM sdb_ome_members");
$total = $members['_total'];
$page_limit = 1000;
$page_count = ceil($total/$page_limit);
//limit ".$page_offset.",".$page_limit.""
for($page=1;$page<=$page_count;$page++){

	$page_offset = ($page-1)*$page_limit;
	$member_list = $db->select("SELECT m.*,s.shop_id FROM sdb_ome_members as m LEFT JOIN sdb_ome_shop_members as s ON m.member_id=s.member_id");
	foreach($member_list as $member){
		$shop_id = $member['shop_id'];
		$member_id = $member['member_id'];
		$shop_type = $shop_list[$shop_id]['shop_type'];

		$db->exec("UPDATE sdb_ome_members SET shop_id='".$shop_id."',shop_type='".$shop_type."' WHERE member_id=".$member_id." AND shop_id='' AND shop_type=''");
		//保存至地址表
		create_address($member);
	}
}

function create_address($members){
	$db = kernel::database();
	$member_id = $members['member_id'];
	$ship_name = $members['name'];
	$ship_area = $members['area'];
	$ship_addr = $members['addr'];
	$ship_mobile = $members['mobile'];
	$ship_tel = $members['tel'];
	$ship_zip = $members['zip'];
	$ship_email = $members['ship_email'];
	$address_hash = sprintf('%u',crc32($ship_name.'-'.$ship_area.'-'.$ship_addr.'-'.$ship_mobile.'-'.$ship_tel.'-'.$ship_zip.'-'.$ship_email));
    $data['address_hash'] = $address_hash;
	
	$address = $db->select("SELECT address_id FROM sdb_ome_member_address WHERE member_id=".$members['member_id']." AND address_hash='".$address_hash."'");
	if(!$address){
		$SQL = "INSERT INTO sdb_ome_member_address(member_id,ship_name,ship_area,ship_addr,ship_mobile,ship_tel,ship_zip,ship_email,address_hash) VALUES('$member_id','$ship_name','$ship_area','$ship_addr','$ship_mobile','$ship_tel','$ship_zip','$ship_email','$address_hash')";
		
		$db->exec($SQL);
	}
}


